/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as accessPackage from './access-package';
export * as accessPackageAssignmentPolicy from './access-package-assignment-policy';
export * as accessPackageCatalog from './access-package-catalog';
export * as accessPackageCatalogRoleAssignment from './access-package-catalog-role-assignment';
export * as accessPackageResourceCatalogAssociation from './access-package-resource-catalog-association';
export * as accessPackageResourcePackageAssociation from './access-package-resource-package-association';
export * as administrativeUnit from './administrative-unit';
export * as administrativeUnitMember from './administrative-unit-member';
export * as administrativeUnitRoleMember from './administrative-unit-role-member';
export * as appRoleAssignment from './app-role-assignment';
export * as application from './application';
export * as applicationApiAccess from './application-api-access';
export * as applicationAppRole from './application-app-role';
export * as applicationCertificate from './application-certificate';
export * as applicationFallbackPublicClient from './application-fallback-public-client';
export * as applicationFederatedIdentityCredential from './application-federated-identity-credential';
export * as applicationFromTemplate from './application-from-template';
export * as applicationIdentifierUri from './application-identifier-uri';
export * as applicationKnownClients from './application-known-clients';
export * as applicationOptionalClaims from './application-optional-claims';
export * as applicationOwner from './application-owner';
export * as applicationPassword from './application-password';
export * as applicationPermissionScope from './application-permission-scope';
export * as applicationPreAuthorized from './application-pre-authorized';
export * as applicationRedirectUris from './application-redirect-uris';
export * as applicationRegistration from './application-registration';
export * as authenticationStrengthPolicy from './authentication-strength-policy';
export * as claimsMappingPolicy from './claims-mapping-policy';
export * as conditionalAccessPolicy from './conditional-access-policy';
export * as customDirectoryRole from './custom-directory-role';
export * as directoryRole from './directory-role';
export * as directoryRoleAssignment from './directory-role-assignment';
export * as directoryRoleEligibilityScheduleRequest from './directory-role-eligibility-schedule-request';
export * as directoryRoleMember from './directory-role-member';
export * as group from './group';
export * as groupMember from './group-member';
export * as groupRoleManagementPolicy from './group-role-management-policy';
export * as invitation from './invitation';
export * as namedLocation from './named-location';
export * as privilegedAccessGroupAssignmentSchedule from './privileged-access-group-assignment-schedule';
export * as privilegedAccessGroupEligibilitySchedule from './privileged-access-group-eligibility-schedule';
export * as servicePrincipal from './service-principal';
export * as servicePrincipalCertificate from './service-principal-certificate';
export * as servicePrincipalClaimsMappingPolicyAssignment from './service-principal-claims-mapping-policy-assignment';
export * as servicePrincipalDelegatedPermissionGrant from './service-principal-delegated-permission-grant';
export * as servicePrincipalPassword from './service-principal-password';
export * as servicePrincipalTokenSigningCertificate from './service-principal-token-signing-certificate';
export * as synchronizationJob from './synchronization-job';
export * as synchronizationJobProvisionOnDemand from './synchronization-job-provision-on-demand';
export * as synchronizationSecret from './synchronization-secret';
export * as user from './user';
export * as userFlowAttribute from './user-flow-attribute';
export * as dataAzureadAccessPackage from './data-azuread-access-package';
export * as dataAzureadAccessPackageCatalog from './data-azuread-access-package-catalog';
export * as dataAzureadAccessPackageCatalogRole from './data-azuread-access-package-catalog-role';
export * as dataAzureadAdministrativeUnit from './data-azuread-administrative-unit';
export * as dataAzureadApplication from './data-azuread-application';
export * as dataAzureadApplicationPublishedAppIds from './data-azuread-application-published-app-ids';
export * as dataAzureadApplicationTemplate from './data-azuread-application-template';
export * as dataAzureadClientConfig from './data-azuread-client-config';
export * as dataAzureadDirectoryObject from './data-azuread-directory-object';
export * as dataAzureadDirectoryRoleTemplates from './data-azuread-directory-role-templates';
export * as dataAzureadDirectoryRoles from './data-azuread-directory-roles';
export * as dataAzureadDomains from './data-azuread-domains';
export * as dataAzureadGroup from './data-azuread-group';
export * as dataAzureadGroupRoleManagementPolicy from './data-azuread-group-role-management-policy';
export * as dataAzureadGroups from './data-azuread-groups';
export * as dataAzureadNamedLocation from './data-azuread-named-location';
export * as dataAzureadServicePrincipal from './data-azuread-service-principal';
export * as dataAzureadServicePrincipals from './data-azuread-service-principals';
export * as dataAzureadUser from './data-azuread-user';
export * as dataAzureadUsers from './data-azuread-users';
export * as provider from './provider';
